//
//  Word.m
//  WordLearning
//
//  Created by neoman on 5/23/13.
//  Copyright (c) 2013 org.codesme. All rights reserved.
//

#import "Word.h"
#import "WordStore.h"

@interface Word ()

@end

@implementation Word

@synthesize nameCh, nameEn, phoneticEn, phoneticUs, sentenceCh, sentenceEn, lastCheck;

- (id)initWithCoder:(NSCoder *)aDecoder
{
    self = [super init];
    if (self) {
        self.nameEn = [aDecoder decodeObjectForKey:@"nameEn"];
        self.nameCh = [aDecoder decodeObjectForKey:@"nameCh"];
        self.phoneticEn = [aDecoder decodeObjectForKey:@"phoneticEn"];
        self.phoneticUs = [aDecoder decodeObjectForKey:@"phoneticUs"];
        self.sentenceCh = [aDecoder decodeObjectForKey:@"sentenceCh"];
        self.sentenceEn = [aDecoder decodeObjectForKey:@"sentenceEn"];
        
        self.lastCheck = [aDecoder decodeObjectForKey:@"lastCheck"];
    }
    
    return self;
}

- (void)encodeWithCoder:(NSCoder *)aCoder
{
    [aCoder encodeObject:self.nameEn forKey:@"nameEn"];
    [aCoder encodeObject:self.nameCh forKey:@"nameCh"];
    [aCoder encodeObject:self.phoneticEn forKey:@"phoneticEn"];
    [aCoder encodeObject:self.phoneticUs forKey:@"phoneticUs"];
    [aCoder encodeObject:self.sentenceCh forKey:@"sentenceCh"];
    [aCoder encodeObject:self.sentenceEn forKey:@"sentenceEn"];
    
    [aCoder encodeObject:self.lastCheck forKey:@"lastCheck"];
}

- (void)readFromJsonData:(NSDictionary *)dictionary
{
    NSString *status = [dictionary objectForKey:@"status"];
    
    if ([status isEqual:@"ok"]) {
        NSDictionary *card = [dictionary objectForKey:@"card"];
        self.nameEn = [card objectForKey:@"en"];
        self.nameCh = [[card objectForKey:@"cn"] stringByReplacingPercentEscapesUsingEncoding:NSUTF8StringEncoding];;
        
        NSDictionary *sentences = [card objectForKey:@"ss"];
        self.sentenceEn = [sentences objectForKey:@"en"];
        self.sentenceCh = [[sentences objectForKey:@"cn"] stringByReplacingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
        
        NSDictionary *phonetic = [card objectForKey:@"ph"];
        self.phoneticEn = [phonetic objectForKey:@"en"];
        if ([[NSNull null] isEqual:self.phoneticEn] ) {
            self.phoneticEn = nil;
        } else {
            self.phoneticEn = [self.phoneticEn stringByReplacingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
        }
        self.phoneticUs = [phonetic objectForKey:@"us"];
        if ([[NSNull null] isEqual:self.phoneticUs] ) {
            self.phoneticUs = nil;
        } else {
            self.phoneticUs = [self.phoneticUs stringByReplacingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
        }
        
        self.lastCheck = [NSDate date];
    }
}

- (NSString *)wordStatics
{
    return [[WordStore sharedStore] rememberHowMany];
}

@end
